# khtml Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# DOM::Document Class Reference

The `Document` interface represents the entire HTML or XML document. More...

`#include <dom_doc.h>`

Inheritance diagram for DOM::Document:

[legend]
Collaboration diagram for DOM::Document:

[legend]
List of all members.

## Public Member Functions

| Document (bool)
| Document (const Document &other)
| Document (const Node &other)
Document & | operator= (const Node &other)
Document & | operator= (const Document &other)
DocumentType | doctype () const
DOMImplementation | implementation () const
Element | documentElement () const
Element | createElement (const DOMString &tagName)
Element | createElementNS (const DOMString &namespaceURI, const DOMString &qualifiedName)
DocumentFragment | createDocumentFragment ()
Text | createTextNode (const DOMString &data)
Comment | createComment (const DOMString &data)
CDATASection | createCDATASection (const DOMString &data)
ProcessingInstruction | createProcessingInstruction (const DOMString &target, const DOMString &data)
Attr | createAttribute (const DOMString &name)
Attr | createAttributeNS (const DOMString &namespaceURI, const DOMString &qualifiedName)
EntityReference | createEntityReference (const DOMString &name)
Element | getElementById (const DOMString &elementId) const
NodeList | getElementsByTagName (const DOMString &tagname)
NodeList | getElementsByTagNameNS (const DOMString &namespaceURI, const DOMString &localName)
Node | importNode (const Node &importedNode, bool deep)
bool | isHTMLDocument () const
Range | createRange ()
NodeIterator | createNodeIterator (Node root, unsigned long whatToShow, NodeFilter filter, bool entityReferenceExpansion)
TreeWalker | createTreeWalker (Node root, unsigned long whatToShow, NodeFilter filter, bool entityReferenceExpansion)
Event | createEvent (const DOMString &eventType)
AbstractView | defaultView () const
StyleSheetList | styleSheets () const
DOMString | preferredStylesheetSet ()
DOMString | selectedStylesheetSet ()
void | setSelectedStylesheetSet (const DOMString &aString)
void | addStyleSheet (const StyleSheet &sheet)
void | removeStyleSheet (const StyleSheet &sheet)
KHTMLView * | view () const
CSSStyleDeclaration | getOverrideStyle (const Element &elt, const DOMString &pseudoElt)
bool | async () const
void | setAsync (bool)
void | abort ()
void | load (const DOMString &uri)
void | loadXML (const DOMString &source)
bool | designMode () const
void | setDesignMode (bool enable)
DOMString | completeURL (const DOMString &url)
DOMString | toString () const
void | updateRendering ()
| Document (DocumentImpl *i)

## Friends

class | ::KHTMLView
class | ::KHTMLPart
class | AbstractView
class | DOMImplementation
class | HTMLFrameElement
class | HTMLIFrameElement
class | HTMLObjectElement
class | Node

## Detailed Description

The `Document` interface represents the entire HTML or XML document.

Conceptually, it is the root of the document tree, and provides the primary access to the document's data.

Since elements, text nodes, comments, processing instructions, etc. cannot exist outside the context of a `Document` , the `Document` interface also contains the factory methods needed to create these objects. The `Node` objects created have a `ownerDocument` attribute which associates them with the `Document` within whose context they were created.

Definition at line 245 of file dom_doc.h.

## Constructor & Destructor Documentation

DOM::Document::Document | ( | bool |  | ) |

| don't create an implementation if false use at own risk Definition at line 162 of file dom_doc.cpp.

## Member Function Documentation

DocumentType DOM::Document::doctype | ( |  | ) | const

| The Document Type Declaration (see `DocumentType` ) associated with this document. For HTML documents as well as XML documents without a document type declaration this returns `null` . The DOM Level 1 does not support editing the Document Type Declaration, therefore `docType` cannot be altered in any way. Definition at line 210 of file dom_doc.cpp.

DOMImplementation DOM::Document::implementation | ( |  | ) | const

| The `DOMImplementation` object that handles this document. A DOM application may use objects from multiple implementations. Definition at line 216 of file dom_doc.cpp.

Element DOM::Document::documentElement | ( |  | ) | const

| This is a convenience attribute that allows direct access to the child node that is the root element of the document. For HTML documents, this is the element with the tagName "HTML". Definition at line 222 of file dom_doc.cpp.

Element DOM::Document::createElement | ( | const DOMString & | tagName | ) |

Creates an element of the type specified.

Note that the instance returned implements the Element interface, so attributes can be specified directly on the returned object.

Parameters:

  | tagName | The name of the element type to instantiate. For XML, this is case-sensitive. For HTML, the `tagName` parameter may be provided in any case, but it must be mapped to the canonical uppercase form by the DOM implementation.

Returns:
  A new `Element` object.

Exceptions:

  | DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.

Definition at line 228 of file dom_doc.cpp.

Element DOM::Document::createElementNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | qualifiedName
| ) |

Introduced in DOM Level 2 Creates an element of the given qualified name and namespace URI.

Parameters:

  | namespaceURI | The namespace URI of the element to create.
  | qualifiedName | The qualified name of the element type to instantiate.

Returns:
  A new Element object with the following attributes:

Exceptions:

  | INVALID_CHARACTER_ERR | Raised if the specified qualified name contains an illegal character.
  | NAMESPACE_ERR | Raised if the qualifiedName is malformed, if the qualifiedName has a prefix and the namespaceURI is null, or if the qualifiedName has a prefix that is "xml" and the namespaceURI is different from "http://www.w3.org/XML/1998/namespace"

Definition at line 240 of file dom_doc.cpp.

DocumentFragment DOM::Document::createDocumentFragment | ( |  | ) |

Creates an empty `DocumentFragment` object.

Returns:
  A new `DocumentFragment` .

Definition at line 252 of file dom_doc.cpp.

Text DOM::Document::createTextNode | ( | const DOMString & | data | ) |

Creates a `Text` node given the specified string.

Parameters:

  | data | The data for the node.

Returns:
  The new `Text` object.

Definition at line 258 of file dom_doc.cpp.

Comment DOM::Document::createComment | ( | const DOMString & | data | ) |

Creates a `Comment` node given the specified string.

Parameters:

  | data | The data for the node.

Returns:
  The new `Comment` object.

Definition at line 264 of file dom_doc.cpp.

CDATASection DOM::Document::createCDATASection | ( | const DOMString & | data | ) |

Creates a `CDATASection` node whose value is the specified string.

Parameters:

  | data | The data for the `CDATASection` contents.

Returns:
  The new `CDATASection` object.

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

Definition at line 270 of file dom_doc.cpp.

ProcessingInstruction DOM::Document::createProcessingInstruction | ( | const DOMString & | target,
|  | const DOMString & | data
| ) |

Creates a `ProcessingInstruction` node given the specified name and data strings.

Parameters:

  | target | The target part of the processing instruction.
  | data | The data for the node.

Returns:
  The new `ProcessingInstruction` object.

Exceptions:

  | DOMException | INVALID_CHARACTER_ERR: Raised if an invalid character is specified.

NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

Definition at line 277 of file dom_doc.cpp.

Attr DOM::Document::createAttribute | ( | const DOMString & | name | ) |

Creates an `Attr` of the given name.

Note that the `Attr` instance can then be set on an `Element` using the `setAttribute` method.

Parameters:

  | name | The name of the attribute.

Returns:
  A new `Attr` object.

Exceptions:

  | DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.

Definition at line 283 of file dom_doc.cpp.

References QString::isNull().

Attr DOM::Document::createAttributeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | qualifiedName
| ) |

Introduced in DOM Level 2 Creates an attribute of the given qualified name and namespace URI.

HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to create.
  | qualifiedName | The qualified name of the attribute to instantiate.

Returns:
  A new Attr object with the following attributes: Node.nodeName - qualifiedName Node.namespaceURI - namespaceURI Node.prefix - prefix, extracted from qualifiedName, or null if there is no prefix Node.localName - local name, extracted from qualifiedName Attr.name - qualifiedName Node.nodeValue - the empty string

Exceptions:

  | INVALID_CHARACTER_ERR | Raised if the specified qualified name contains an illegal character.
  | NAMESPACE_ERR | Raised if the qualifiedName is malformed, if the qualifiedName has a prefix and the namespaceURI is null, if the qualifiedName has a prefix that is "xml" and the namespaceURI is different from "http://www.w3.org/XML/1998/namespace", or if the qualifiedName is "xmlns" and the namespaceURI is different from "http://www.w3.org/2000/xmlns/".

Definition at line 294 of file dom_doc.cpp.

EntityReference DOM::Document::createEntityReference | ( | const DOMString & | name | ) |

Creates an EntityReference object.

Parameters:

  | name | The name of the entity to reference.

Returns:
  The new `EntityReference` object.

Exceptions:

  | DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.

NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

Definition at line 305 of file dom_doc.cpp.

Element DOM::Document::getElementById | ( | const DOMString & | elementId | ) | const

Moved from HTMLDocument in DOM Level 2 Returns the Element whose `id` is given by elementId.

If no such element exists, returns `null` . Behavior is not defined if more than one element has this `id` .

Parameters:

  | elementId | The unique `id` value for an element.

Returns:
  The matching element.

Definition at line 311 of file dom_doc.cpp.

NodeList DOM::Document::getElementsByTagName | ( | const DOMString & | tagname | ) |

No Exceptions.

Returns a `NodeList` of all the `Element` 's with a given tag name in the order in which they would be encountered in a preorder traversal of the `Document` tree.

Parameters:

  | tagname | The name of the tag to match on. The special value "*" matches all tags.

Returns:
  A new `NodeList` object containing all the matched `Element` s.

Definition at line 317 of file dom_doc.cpp.

NodeList DOM::Document::getElementsByTagNameNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |

Introduced in DOM Level 2 No Exceptions.

Returns a NodeList of all the Elements with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of the Document tree.

Parameters:

  | namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  | localName | The local name of the elements to match on. The special value "*" matches all local names.

Returns:
  A new NodeList object containing all the matched Elements.

Definition at line 328 of file dom_doc.cpp.

Node DOM::Document::importNode | ( | const Node & | importedNode,
|  | bool | deep
| ) |

Introduced in DOM Level 2.

Imports a node from another document to this document. The returned node has no parent; (parentNode is null). The source node is not altered or removed from the original document; this method creates a new copy of the source node.

For all nodes, importing a node creates a node object owned by the importing document, with attribute values identical to the source node's nodeName and nodeType, plus the attributes related to namespaces (prefix, localName, and namespaceURI).

As in the cloneNode operation on a Node, the source node is not altered. Additional information is copied as appropriate to the nodeType, attempting to mirror the behavior expected if a fragment of XML or HTML source was copied from one document to another, recognizing that the two documents may have different DTDs in the XML case. The following list describes the specifics for each type of node.

ATTRIBUTE_NODE The ownerElement attribute is set to null and the specified flag is set to true on the generated Attr. The descendants of the source Attr are recursively imported and the resulting nodes reassembled to form the corresponding subtree. Note that the deep parameter has no effect on Attr nodes; they always carry their children with them when imported.

DOCUMENT_FRAGMENT_NODE If the deep option was set to true, the descendants of the source element are recursively imported and the resulting nodes reassembled to form the corresponding subtree. Otherwise, this simply generates an empty DocumentFragment.

DOCUMENT_NODE Document nodes cannot be imported.

DOCUMENT_TYPE_NODE DocumentType nodes cannot be imported.

ELEMENT_NODE Specified attribute nodes of the source element are imported, and the generated Attr nodes are attached to the generated Element. Default attributes are not copied, though if the document being imported into defines default attributes for this element name, those are assigned. If the importNode deep parameter was set to true, the descendants of the source element are recursively imported and the resulting nodes reassembled to form the corresponding subtree.

ENTITY_NODE Entity nodes can be imported, however in the current release of the DOM the DocumentType is readonly. Ability to add these imported nodes to a DocumentType will be considered for addition to a future release of the DOM. On import, the publicId, systemId, and notationName attributes are copied. If a deep import is requested, the descendants of the the source Entity are recursively imported and the resulting nodes reassembled to form the corresponding subtree.

ENTITY_REFERENCE_NODE Only the EntityReference itself is copied, even if a deep import is requested, since the source and destination documents might have defined the entity differently. If the document being imported into provides a definition for this entity name, its value is assigned.

NOTATION_NODE Notation nodes can be imported, however in the current release of the DOM the DocumentType is readonly. Ability to add these imported nodes to a DocumentType will be considered for addition to a future release of the DOM. On import, the publicId and systemId attributes are copied. Note that the deep parameter has no effect on Notation nodes since they never have any children.

PROCESSING_INSTRUCTION_NODE The imported node copies its target and data values from those of the source node.

TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE These three types of nodes inheriting from CharacterData copy their data and length attributes from those of the source node.

Parameters:

  | importedNode | The node to import.
  | deep | If true, recursively import the subtree under the specified node; if false, import only the node itself, as explained above. This has no effect on Attr, EntityReference, and Notation nodes.

Returns:
  The imported node that belongs to this Document.

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if the type of node being imported is not supported.

Definition at line 334 of file dom_doc.cpp.

Range DOM::Document::createRange | ( |  | ) |

Introduced in DOM Level 2 This method is from the DocumentRange interface.

Returns:
  Range The initial state of the Range returned from this method is such that both of its boundary-points are positioned at the beginning of the corresponding Document, before any content. The Range returned can only be used to select content associated with this Document, or with DocumentFragments and Attrs for which this Document is the ownerDocument.

Definition at line 352 of file dom_doc.cpp.

Referenced by KHTMLPart::selection().

NodeIterator DOM::Document::createNodeIterator | ( | Node | root,
|  | unsigned long | whatToShow,
|  | NodeFilter | filter,
|  | bool | entityReferenceExpansion
| ) |

Introduced in DOM Level 2 This method is from the DocumentTraversal interface.

Create a new NodeIterator over the subtree rooted at the specified node.

Parameters:

  | root | The node which will be iterated together with its children. The iterator is initially positioned just before this node. The whatToShow flags and the filter, if any, are not considered when setting this position. The root must not be null.
  | whatToShow | This flag specifies which node types may appear in the logical view of the tree presented by the iterator. See the description of NodeFilter for the set of possible SHOW_ values. These flags can be combined using OR.
  | filter | The NodeFilter to be used with this NodeIterator, or null to indicate no filter.
  | entityReferenceExpansion | The value of this flag determines whether entity reference nodes are expanded.

Returns:
  NodeIterator The newly created NodeIterator.

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if the specified root is null.

Definition at line 358 of file dom_doc.cpp.

References DOM::Node::handle().

TreeWalker DOM::Document::createTreeWalker | ( | Node | root,
|  | unsigned long | whatToShow,
|  | NodeFilter | filter,
|  | bool | entityReferenceExpansion
| ) |

Introduced in DOM Level 2 This method is from the DocumentTraversal interface.

Create a new TreeWalker over the subtree rooted at the specified node.

Parameters:

  root

  The node which will serve as the root for the TreeWalker. The whatToShow flags and the NodeFilter are not considered when setting this value; any node type will be accepted as the root. The currentNode of the TreeWalker is initialized to this node, whether or not it is visible. The root functions as a stopping point for traversal methods that look upward in the document structure, such as parentNode and nextNode. The root must not be null.

  | whatToShow | This flag specifies which node types may appear in the logical view of the tree presented by the tree-walker. See the description of NodeFilter for the set of possible SHOW_ values. These flags can be combined using OR.
  | filter | The NodeFilter to be used with this TreeWalker, or null to indicate no filter.
  | entityReferenceExpansion | If this flag is false, the contents of EntityReference nodes are not presented in the logical view.

Returns:
  The newly created TreeWalker.

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if the specified root is null.

Definition at line 372 of file dom_doc.cpp.

References DOM::NodeFilter::handle(), and DOM::Node::handle().

Event DOM::Document::createEvent | ( | const DOMString & | eventType | ) |

Introduced in DOM Level 2 This method is from the DocumentEvent interface.

The createEvent method is used in creating Events when it is either inconvenient or unnecessary for the user to create an Event themselves. In cases where the implementation provided Event is insufficient, users may supply their own Event implementations for use with the dispatchEvent method.

Parameters:

  eventType

  The eventType parameter specifies the type of Event interface to be created. If the Event interface specified is supported by the implementation this method will return a new Event of the interface type requested. If the Event is to be dispatched via the dispatchEvent method the appropriate event init method must be called after creation in order to initialize the Event's values. As an example, a user wishing to synthesize some kind of UIEvent would call createEvent with the parameter "UIEvents". The initUIEvent method could then be called on the newly created UIEvent to set the specific type of UIEvent to be dispatched and set its context information.

Returns:
  The newly created EventExceptions

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if the implementation does not support the type of Event interface requested

Definition at line 388 of file dom_doc.cpp.

AbstractView DOM::Document::defaultView | ( |  | ) | const

| Introduced in DOM Level 2 This method is from the DocumentView interface. The default AbstractView for this Document, or null if none available. Definition at line 400 of file dom_doc.cpp.

StyleSheetList DOM::Document::styleSheets | ( |  | ) | const

Introduced in DOM Level 2 This method is from the DocumentStyle interface.

A list containing all the style sheets explicitly linked into or embedded in a document. For HTML documents, this includes external style sheets, included via the HTML LINK element, and inline STYLE elements. In XML, this includes external style sheets, included via style sheet processing instructions (see [XML-StyleSheet]).

Definition at line 408 of file dom_doc.cpp.

DOMString DOM::Document::preferredStylesheetSet | ( |  | ) |

| CSS3 mechanism for selecting alternate stylesheets using the DOM. Might change without further notice. Definition at line 416 of file dom_doc.cpp.

void DOM::Document::addStyleSheet | ( | const StyleSheet & | sheet | ) |

Adds a new style sheet to the list of style sheets.

The new style sheet will be applied after all author and implicit style sheets, but before the user style sheet.

Create new style sheets with e. g. `DOMImplementation::createCSSStyleSheet`

This is not part of the official DOM.

Parameters:

  | sheet | style sheet

Exceptions:

  | DOMException |

Since:
  3.4

Definition at line 536 of file dom_doc.cpp.

void DOM::Document::removeStyleSheet | ( | const StyleSheet & | sheet | ) |

Removes a style sheet to the list of style sheets.

Only sheets added by `addStyleSheet` may be removed.

This is not part of the official DOM.

Parameters:

  | sheet | style sheet to remove

Exceptions:

  | DOMException | NOT_FOUND_ERR `sheet` is not contained in the list of style sheets or it has not been added by `addStyleSheet`

Since:
  3.4

Definition at line 547 of file dom_doc.cpp.

KHTMLView * DOM::Document::view | ( |  | ) | const

Returns:
  The KHTML view widget of this document.

Definition at line 441 of file dom_doc.cpp.

CSSStyleDeclaration DOM::Document::getOverrideStyle | ( | const Element & | elt,
|  | const DOMString & | pseudoElt
| ) |

Introduced in DOM Level 2 This method is from the DocumentCSS interface.

This method is used to retrieve the override style declaration for a specified element and a specified pseudo-element.

Parameters:

  | elt | The element whose style is to be modified. This parameter cannot be null.
  | pseudoElt | The pseudo-element or null if none.

Returns:
  The override style declaration.

Definition at line 448 of file dom_doc.cpp.

bool DOM::Document::async | ( |  | ) | const

| Introduced in DOM Level 3 This method is from the DocumentLS interface. Indicates whether the method DocumentLS.load() should be synchronous or asynchronous. When the async attribute is set to true the load method returns control to the caller before the document has completed loading. The default value of this attribute is true. Definition at line 460 of file dom_doc.cpp.

void DOM::Document::setAsync | ( | bool |  | ) |

Introduced in DOM Level 3 This method is from the DocumentLS interface.

see async

Exceptions:

  | DOMException | NOT_SUPPORTED_ERR: Raised if the implementation doesn't support the mode the attribute is being set to.

Definition at line 468 of file dom_doc.cpp.

void DOM::Document::abort | ( |  | ) |

| Introduced in DOM Level 3 This method is from the DocumentLS interface. If the document is currently being loaded as a result of the method load being invoked the loading and parsing is immediately aborted. The possibly partial result of parsing the document is discarded and the document is cleared. Definition at line 476 of file dom_doc.cpp.

void DOM::Document::load | ( | const DOMString & | uri | ) |

Introduced in DOM Level 3 This method is from the DocumentLS interface.

Replaces the content of the document with the result of parsing the given URI. Invoking this method will either block the caller or return to the caller immediately depending on the value of the async attribute. Once the document is fully loaded a "load" event (as defined in [DOM Level 3 Events], except that the Event.targetNode will be the document, not an element) will be dispatched on the document. If an error occurs, an implementation dependent "error" event will be dispatched on the document. If this method is called on a document that is currently loading, the current load is interrupted and the new URI load is initiated.

When invoking this method the parameters used in the DOMParser interface are assumed to have their default values with the exception that the parameters "entities", "normalize-characters", "check-character-normalization" are set to "false".

The result of a call to this method is the same the result of a call to DOMParser.parseWithContext with an input stream referencing the URI that was passed to this call, the document as the context node, and the action ACTION_REPLACE_CHILDREN.

Parameters:

  | uri | of type DOMString The URI reference for the XML file to be loaded. If this is a relative URI, the base URI used by the implementation is implementation dependent.

Returns:
  If async is set to true load returns true if the document load was successfully initiated. If an error occurred when initiating the document load, load returns false. If async is set to false load returns true if the document was successfully loaded and parsed. If an error occurred when either loading or parsing the URI, load returns false.

Definition at line 485 of file dom_doc.cpp.

void DOM::Document::loadXML | ( | const DOMString & | source | ) |

Introduced in DOM Level 3 This method is from the DocumentLS interface.

Replace the content of the document with the result of parsing the input string, this method is always synchronous. This method always parses from a DOMString, which means the data is always UTF-16. All other encoding information is ignored.

The parameters used in the DOMParser interface are assumed to have their default values when invoking this method.

The result of a call to this method is the same as the result of a call to DOMParser.parseWithContext with an input stream containing the string passed to this call, the document as the context node, and the action ACTION_REPLACE_CHILDREN.

Parameters:

  | source | A string containing an XML document.

Definition at line 493 of file dom_doc.cpp.

bool DOM::Document::designMode | ( |  | ) | const

not part of the official DOM

Documents are read-only by default, but they can be made editable by entering "design mode".

Returns:
  whether this document is in design mode.

Since:
  3.2

Definition at line 502 of file dom_doc.cpp.

void DOM::Document::setDesignMode | ( | bool | enable | ) |

not part of the official DOM

Parameters:

  | enable | `true` to enable design mode, `false` to disable.

See also:
  designMode

Since:
  3.2

Definition at line 509 of file dom_doc.cpp.

DOMString DOM::Document::completeURL | ( | const DOMString & | url | ) |

| not part of the DOM completes a given URL Definition at line 516 of file dom_doc.cpp.

void DOM::Document::updateRendering | ( |  | ) |

| not part of the DOM Updates the rendered display after one or more changes to the DOM structure Definition at line 530 of file dom_doc.cpp.

The documentation for this class was generated from the following files:

- dom_doc.h
- dom_doc.cpp

This file is part of the documentation for khtml Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:33:42 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003